Attribute VB_Name = "ByteHelperFunctions"
Option Explicit
Public Function Byte2String(InByte() As Byte, OutString As String) As Boolean
  'Convert byte array to string
   
   Dim I As Integer
   
   If (UBound(InByte) = 0) Or _
      (Len(OutString) < (UBound(InByte) + 1)) Then
      Byte2String = False
      Exit Function
   End If
   
   OutString = StrConv(InByte(), vbUnicode)
'   For I = 0 To UBound(InByte) - 1
'      Mid(OutString, I + 1, 1) = Chr(InByte(I))
'   Next I
   Byte2String = True
End Function

Public Function szByte2StringB(InByte() As Byte, OutString As String) As Boolean
  'Convert byte array to string
   
   Dim I As Integer, j As Integer
   Dim c As Byte
   
   If (UBound(InByte) = 0) Then
      szByte2StringB = False
      Exit Function
   End If
   
   For I = 0 To UBound(InByte, 1)
      c = InByte(I, j)
      If InByte(j, I) = 0 Then Exit For               'stop at null
      Mid(OutString, I + 1, 1) = Chr(c)
   Next I
   szByte2StringB = True
End Function


Public Function String2Byte(InString As String, OutByte() As Byte) As Boolean
  'vb byte-array / string coercion assumes unicode string
  'so must copy hex data this way...
  'ASSUMPTIONS:
  '   Byte array is sized before being passed
  '   Byte array is padded with nulls if > size of string
   
   Dim I As Integer
   Dim SizeOutByte As Integer
   Dim SizeInString As Integer
   
   SizeOutByte = UBound(OutByte) - LBound(OutByte) + 1
   SizeInString = Len(InString)
   
   'Check for valid sizes
   If (SizeInString = 0) Or _
      (SizeOutByte < SizeInString) Then
      String2Byte = False
      Exit Function
   End If
   
   'Convert the string
   For I = 0 To SizeInString - 1
      OutByte(I) = AscB(Mid(InString, I + 1, 1))
   Next I
   'If byte array > len of string pad
   If SizeOutByte > SizeInString Then           'Pad with Nulls
      For I = SizeInString To UBound(OutByte)
         OutByte(I) = 0
      Next I
   End If
   'ViewByteArray OutByte, "String2Byte"
   String2Byte = True
End Function
Public Function String2Byte2D(InString As String, OutByte() As Byte, RowIdx As Long) As Boolean
  'VB byte arrays are layed out in memory opposite of C.  The string would
  'be by column instead of by row so must flip flop the string.
  'ASSUMPTIONS:
  '   Byte array is sized before being passed
  '   Byte array is padded with nulls if > size of string
   
   Dim I As Integer
   Dim SizeOutByte As Integer
   Dim SizeInString As Integer
   
   SizeInString = Len(InString)
   SizeOutByte = UBound(OutByte, 1)
      
   'Convert the string
   For I = 0 To SizeInString - 1
      OutByte(I, RowIdx) = AscB(Mid(InString, I + 1, 1))
   Next I
   'If byte array > len of string pad
   If SizeOutByte > SizeInString Then             'Pad with Nulls
      For I = SizeInString To SizeOutByte - 1
         OutByte(I, RowIdx) = 0
      Next I
   End If
   'ViewByteArray OutByte, "String2Byte"
   String2Byte2D = True
End Function



Public Sub ViewByteArray(Data() As Byte, Title As String)
   'Display message box showing hex values of byte array
   
   Dim S As String
   Dim I As Integer
   Dim B As Byte
   
   On Error GoTo VBANext
   
   S = "Length: " & Str(UBound(Data) - LBound(Data) + 1) & "  Data (in hex):"
   For I = LBound(Data) To UBound(Data)
      If (I Mod 8) = 0 Then
         S = S & "  "         'add extra space every 10th byte
      End If
      B = Data(I)
      S = S & Hex(Data(I)) & " "
VBANext:
   Next I
   
   MsgBox S, , Title
   
End Sub

Public Function Sizeof(abData() As Byte) As Integer
   Sizeof = UBound(abData) - LBound(abData) + 1
End Function

Public Sub ViewHex(S As String, Title As String)
'dxd  Used to view string as hex...
   Dim I As Integer
   Dim HexString As String
   
   On Error GoTo NextNum
   HexString = ""
   For I = 1 To Len(S)
      'add hex  Str(Asc((Mid(S, I, 1)))) & " "
      HexString = HexString + Hex(Asc((Mid(S, I, 1)))) & " "
NextNum:
   Next I
   MsgBox HexString, 0, Title
End Sub


