Attribute VB_Name = "cwbsy"
'*********************************************************************
'Translated to VB Declares                                         DXD
'NOTE:  These declares assume that all input strings are passed
' from a VB string data type.  All input/output or output strings
' are passed as an array of BYTE data type.  This avoids the problems
' with VB moving the string in memory.
'
'11/97 Added all list related apis (untested)
'/********************************************************************/
'/* Copyright = 5763-XA1 (C) Copyright IBM Corp 1994, 1996.          */
'/*  All rights reserved.                                            */
'/*  Licensed Material - Program property of IBM                     */
'/*  Refer to copyright instructions form number G120-2083.          */
'/********************************************************************/
'/********************************************************************/
'/*                                                                  */
'/* Module:                                                          */
'/*   CWBSY.H                                                        */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   It contains the declarations for the following API's:          */
'/*                                                                  */
'/*   cwbSY_CreateSecurityObj                                        */
'/*   cwbSY_DeleteSecurityObj                                        */
'/*                                                                  */
'/*   cwbSY_SetSys                                                   */
'/*   cwbSY_SetSysA                                                  */
'/*   cwbSY_SetSysW                                                  */
'/*                                                                  */
'/*   cwbSY_VerifyUserIDPwd                                          */
'/*   cwbSY_VerifyUserIDPwdA                                         */
'/*   cwbSY_VerifyUserIDPwdW                                         */
'/*   cwbSY_ChangePwd                                                */
'/*   cwbSY_ChangePwdA                                               */
'/*   cwbSY_ChangePwdW                                               */
'/*   cwbSY_GetUserID                                                */
'/*   cwbSY_GetUserIDA                                               */
'/*   cwbSY_GetUserIDW                                               */
'/*                                                                  */
'/*   cwbSY_Logon                                                    */
'/*                                                                  */
'/*   cwbSY_GetDateTimePwdExpires                                    */
'/*   cwbSY_GetFailedAttempts                                        */
'/*   cwbSY_GetDateTimeLastSignon                                    */
'/*   cwbSY_GetDateTimeCurrentSignon                                 */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   Link with CWBAPI.LIB import library.                           */
'/*   This module is to be used in conjunction with CWBSY.DLL.       */
'/*                                                                  */
'/*   The Security Function allows you to manage the Security of     */
'/*   your information through password control.  The Security APIs  */
'/*   allow you to:                                                  */
'/*     Verify your user ID and password on an AS/400 system         */
'/*     Change your password on an AS/400 system                     */
'/*     Retrieve information about your user ID, such as:            */
'/*     - Date and time your password will expire                    */
'/*     - Date and time of the last successful logon attempt         */
'/*     - Date and time of the current signon                        */
'/*     - Number of failed signon attempts                           */
'/*                                                                  */
'/*   In addition to the return codes listed for APIs additional     */
'/*   operating system specific return codes may also appear.  The   */
'/*   precise meaning of these return codes can be found in the      */
'/*   operating system manuals or relevant header files.             */
'/'*                                                                  */
'/********************************************************************/

'/*------------------------------------------------------------------*/
'/*   User ID does not exist.                                        */
'/*------------------------------------------------------------------*/
Public Const CWBSY_UNKNOWN_USERID = 6001

'/*------------------------------------------------------------------*/
'/*   Password is not correct for specified user ID.                 */
'/*------------------------------------------------------------------*/
Public Const CWBSY_WRONG_PASSWORD = 6002

'/*------------------------------------------------------------------*/
'/*   Password has expired.                                          */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PASSWORD_EXPIRED = 6003

'/*------------------------------------------------------------------*/
'/*   One or more characters in the password is not valid or the     */
'/*   password is too long.                                          */
'/*------------------------------------------------------------------*/
Public Const CWBSY_INVALID_PASSWORD = 6004

'/*------------------------------------------------------------------*/
'/*   A general security error occurred.  The user profile does not  */
'/*   have a password or the password validation program found an    */
'/*   error in the password.                                         */
'/*------------------------------------------------------------------*/
Public Const CWBSY_GENERAL_SECURITY_ERROR = 6007

'/*------------------------------------------------------------------*/
'/*   The AS/400 user profile is not valid.                          */
'/*  ----------------------------------------------------------------*/
Public Const CWBSY_INVALID_PROFILE = 6009

'/*------------------------------------------------------------------*/
'/*   The AS/400 user profile (user ID) has been set to disabled.    */
'/*------------------------------------------------------------------*/
Public Const CWBSY_USER_PROFILE_DISABLED = 60011

'/*------------------------------------------------------------------*/
'/*   The user canceled from the user ID/password prompt.            */
'/*------------------------------------------------------------------*/
Public Const CWBSY_USER_CANCELLED = 60013

'/*------------------------------------------------------------------*/
'/*   One or more characters in the user ID is not valid or the      */
'/*   user ID is too long.                                           */
'/*------------------------------------------------------------------*/
Public Const CWBSY_INVALID_USERID = 60015

'/*------------------------------------------------------------------*/
'/*   The system specified is unknown.                               */
'/*------------------------------------------------------------------*/
Public Const CWBSY_UNKNOWN_SYSTEM = 60016

'/*------------------------------------------------------------------*/
'/*   The PC could not validate the AS/400 security server.  This    */
'/*   could indicate tampering with the IBM supplied security server */
'/*   program on the AS/400.                                         */
'/*------------------------------------------------------------------*/
Public Const CWBSY_TP_NOT_VALID = 60019

'/*------------------------------------------------------------------*/
'/*   There is no user currently logged on for the specified system. */
'/*------------------------------------------------------------------*/
Public Const CWBSY_NOT_LOGGED_ON = 60022

'/*------------------------------------------------------------------*/
'/*   The system specified in the security object has not been       */
'/*   configured.                                                    */
'/*------------------------------------------------------------------*/
Public Const CWBSY_SYSTEM_NOT_CONFIGURED = 60025 '// @A1A

'/*------------------------------------------------------------------*/
'/*   The user ID and password defined in the object has not yet     */
'/*   been verified.   You must verify using cwbSY_verifyUserIDPwd   */
'/*   API.                                                           */
'/*------------------------------------------------------------------*/
Public Const CWBSY_NOT_VERIFIED = 60026

'/*------------------------------------------------------------------*/
'/*   Internal error. Contact IBM Service.                           */
'/*------------------------------------------------------------------*/
Public Const CWBSY_INTERNAL_ERROR = 600255

'/*------------------------------------------------------------------*/
'/*   Change password errors                                         */
'/*------------------------------------------------------------------*/

'/*------------------------------------------------------------------*/
'/*   The new password contains too many characters.  The maximum    */
'/*   number of characters allowed is defined by the AS/400 system   */
'/*   value, QPWDMAXLEN.                                             */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_TOO_LONG = 600257

'/*------------------------------------------------------------------*/
'/*   The new password does not contain enough characters. The       */
'/*   The minimum number of characters allowed is defined by the     */
'/*   AS/400 system value, QPWDMINLEN.                               */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_TOO_SHORT = 600258

'/*------------------------------------------------------------------*/
'/*   The new password contains a character used more than once.     */
'/*   The AS/400 configuration (system value QPWDLMTREP) does not    */
'/*   allow passwords to contain a repeat character.                 */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_REPEAT_CHARACTER = 600259

'/*------------------------------------------------------------------*/
'/*   The new password contains two numbers next to each other.  The */
'/*   The AS/400 configuration (system value QPWDLMTAJC) does not    */
'/*   allow passwords to contain consecutive digits.                 */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_ADJACENT_DIGITS = 600260

'/*------------------------------------------------------------------*/
'/*   The new password contains a character repeated consecutively.  */
'/*   The AS/400 configuration (system value QPWDLMTREP) does not    */
'/*   allow a password to contain a character repeated consecutively.*/
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_CONSECUTIVE_CHARS = 600261

'/*------------------------------------------------------------------*/
'/*   The new password matches a previously used password.  The      */
'/*   AS/400 configuration (system value QPWDRQDDIF) requires new    */
'/*   passwords to be different than any previous password.          */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_PREVIOUSLY_USED = 600262

'/*------------------------------------------------------------------*/
'/*   The new password uses an installation disallowed character.    */
'/*   AS/400 configuration (system value QPWDLMTCHR) restricts       */
'/*   certain characters from being used in new passwords.           */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_DISALLOWED_CHAR = 600263

'/*------------------------------------------------------------------*/
'/*   The new password must contain a number.   The AS/400           */
'/*   configuration (system value QPWDRQDDGT) requires new passwords */
'/*   contain one or more numeric digits.                            */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_NEED_NUMERIC = 600264

'/*------------------------------------------------------------------*/
'/*   The new password matches an old password in one or more        */
'/*   character positions.  The AS/400 configuration (system value   */
'/*   QPWDPOSDIF) does not allow the same character to be in the     */
'/*   same position as a previous password.                          */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_MATCHES_OLD = 600266

'/*------------------------------------------------------------------*/
'/*   The password was rejected                                      */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_NOT_ALLOWED = 600267

'/*------------------------------------------------------------------*/
'/*   The password matches the user ID.                              */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_MATCHES_USERID = 600268

'/*------------------------------------------------------------------*/
'/*   The old password was created on a pre-V3 system which used a   */
'/*   different encryption technique.  Password must be changed      */
'/*   manually on the AS/400.                                        */
'/*------------------------------------------------------------------*/
Public Const CWBSY_PWD_PRE_V3 = 600269

'/*------------------------------------------------------------------*/
'/*   The next invalid will disable the user profile.                */
'/*------------------------------------------------------------------*/
Public Const CWBSY_LAST_INVALID_PASSWORD = 600270


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_ChangePwd                                                */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Changes the password on the specified AS/400 system.           */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   const char * userID - input                                    */
'/*       A pointer to an ASCIIZ string which contains the user ID.  */
'/*       The maximum length is 10 bytes + 1 byte for the null       */
'/*       terminator.                                                */
'/*                                                                  */
'/*   const char * oldPassword - input                               */
'/*       A pointer to an ASCIIZ string which contains the current   */
'/*       password.  The maximum length is 10 bytes + 1 byte for the */
'/*       NULL terminator.                                           */
'/*                                                                  */
'/*   const char * newPassword - input                               */
'/*       A pointer to an ASCIIZ string which contains the new       */
'/*       password.  The maximum length is 10 bytes + 1 byte for the */
'/*       NULL terminator.                                           */
'/*                                                                  */
'/*   cwbSV_ErrHandle errorHandle - output                           */
'/*     Any returned messages will be written to this object.  It    */
'/*     is created with the cwbSV_CreateErrHandle API.  The          */
'/*     messages may be retrieved through the cwbSV_GetErrText API.  */
'/*     If the parameter is set to zero, no messages will be         */
'/*     retrieved.                                                   */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle supplied is           */
'/*                        not valid.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_COMMUNICATIONS_ERROR - A communication error occurred      */
'/*                              when attempting to contact the      */
'/*                              system.                             */
'/*   CWBSY_SYSTEM_NOT_CONFIGURED - The system has not been          */
'/*                                 configured.                      */
'/*   CWBSY_GENERAL_SECURITY_ERROR - A general security error        */
'/*                                  occurred.  The user profile     */
'/*                                  does not have a password or the */
'/*                                  password validation program     */
'/*                                  found an error in the password. */
'/*   CWBSY_INVALID_PASSWORD - One or more characters in the         */
'/*                            password is invalid or the password   */
'/*                            is too long.                          */
'/*   CWBSY_INVALID_USERID - One or more characters in the user ID   */
'/*                          is invalid or the user ID is too long.  */
'/*   CWBSY_UNKNOWN_USERID - The supplied user ID is not             */
'/*                          known to this system.                   */
'/*   CWBSY_WRONG_PASSWORD - Password is not correct.                */
'/*   CWBSY_USER_PROFILE_DISABLED - The user ID has been disabled.   */
'/*   CWBSY_PWD_TOO_LONG - New password longer than maximum          */
'/*                       accepted length.                           */
'/*   CWBSY_PWD_TOO_SHORT - New password shorter than minimum        */
'/*                        accepted length.                          */
'/*   CWBSY_PWD_REPEAT_CHARACTER - New password contains a character */
'/*                               used more than once.               */
'/*   CWBSY_PWD_ADJACENT_DIGITS - New password has adjacent digits.  */
'/*   CWBSY_PWD_CONSECUTIVE_CHARS - New password contains a character*/
'/*                                repeated consecutively.           */
'/*   CWBSY_PWD_PREVIOUSLY_USED - New password was previously used.  */
'/*   CWBSY_PWD_DISALLOWED_CHAR - New password uses an installation  */
'/*                              disallowed character.               */
'/*   CWBSY_PWD_NEED_NUMERIC - New password must contain at          */
'/*                           least one numeric.                     */
'/*   CWBSY_PWD_MATCHES_OLD - New password matches old password      */
'/*                          in one or more character positions.     */
'/*   CWBSY_PWD_NOT_ALLOWED - New password exists in a dictionary of */
'/*                          disallowed passwords.                   */
'/*   CWBSY_PWD_MATCHES_USERID - New password matches the user ID.   */
'/*   CWBSY_PWD_PRE_V3 - The old password was created on a pre-V3    */
'/*                      system which used a different encryption    */
'/*                      technique.  Password must be changed        */
'/*                      manually on the AS/400.                     */
'/*   CWBSY_LAST_INVALID_PASSWORD - The next invalid password        */
'/*                                 will disable the user profile.   */
'/*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory; may have failed   */
'/*                           to allocate temporary buffer.          */
'/*   CWB_NON_REPRESENTABLE_UNICODE_CHAR - One or more input UNICODE */
'/*                                        characters have no        */
'/*                                        representation in the     */
'/*                                        codepage being used.      */
'/*   CWB_API_ERROR - General API failure.                           */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   The system name must be set prior to calling this API by using */
'/*   the cwbSY_SetSys API.                                          */
'/*                                                                  */
'/********************************************************************/
Public Declare Function cwbSY_ChangePwd Lib "cwbsy.dll" ( _
                             ByVal cwbSY_SecurityHandle As Long, _
                             ByVal UserID As String, _
                             ByVal oldPassword As String, _
                             ByVal newPassword As String, _
                             ByVal errorHandle As Long) _
                             As Long

'Public Declare Function cwbSY_ChangePwd(
'                             cwbSY_SecurityHandle  securityHandle,
'                             const char           *userID,
'                             const char           *oldPassword,
'                             const char           *newPassword,
'                             cwbSV_ErrHandle       errorHandle);

'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_CreateSecurityObj                                        */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Creates a security object.  When you are finished using the    */
'/*   object you should delete it using the cwbSY_DeleteSecurityObj  */
'/*   API.                                                           */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - output                   */
'/*        Pointer to a cwbSY_SecurityHandle.  If the create is      */
'/*        successful this will contain a handle to the newly        */
'/*        created security object.  This handle is required on the  */
'/*        other security APIs.                                      */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_NOT_ENOUGH_MEMORY - Not enough memory available to create  */
'/*                           object.                                */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
Public Declare Function cwbSY_CreateSecurityObj Lib "cwbsy.dll" ( _
                             ByRef securityHandle As Long) _
                             As Long

'Public Declare Function cwbSY_CreateSecurityObj(
'                             cwbSY_SecurityHandle *securityHandle);

'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_DeleteSecurityObj                                        */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Deletes a security object.                                     */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_DeleteSecurityObj(
'                             cwbSY_SecurityHandle SecurityHandle);
Public Declare Function cwbSY_DeleteSecurityObj Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_GetDateTimeCurrentSignon                                 */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Retrieves the date and time of the current successful signon.  */
'/*   You must have successfully called cwbSY_verifyUserIDPwd        */
'/*   before using this API.                                         */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   unsigned char * lastSignonDateTime - output                    */
'/*       A pointer to 8 bytes which will contain the date and time  */
'/*       when the current signon occurred in this format:           */
'/*                                                                  */
'/*       Bytes     Content                                          */
'/*       --------  -----------------------------------------------  */
'/*       1 - 2     Year (Example: 1994 = 0x07CA)                    */
'/*       3         Month (January = 0x01)                           */
'/*       4         Day   (First day = 0x01;31st day = 0x1F)         */
'/*       5         Hour  (Midnight = 0x01;23rd hour = 0x17)         */
'/*       6         Minute (On the hour = 0x00; 59th minute = 0x3B)  */
'/*       7         Second (On the minute = 0x00; 59th second = 0x3B)*/
'/*       8         One-hundredth of a second (on the second = 0x00; */
'/*                 maximum = 0x63)                                  */
'/*                                                                  */
'/*   Note: On a given day, the maximum time is 23 hours, 59         */
'/*         minutes, and 59.99 seconds.  Midnight is 0 hours, 0      */
'/*         minutes and 0.0 seconds on the following day.            */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWBSY_NOT_VERIFIED - The user ID and password defined in       */
'/*                        object has not been verified.  Make sure  */
'/*                        you have first called                     */
'/*                        cwbSY_verifyUserIDPwd before using        */
'/*                        this API.                                 */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_GetDateTimeCurrentSignon(
'                             cwbSY_SecurityHandle  securityHandle,
'                             unsigned char        *currentSignonDateTime);
Public Declare Function cwbSY_GetDateTimeCurrentSignon Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByRef currentSignonDateTime As Byte) _
                             As Long

'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_GetDateTimeLastSignon                                    */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Retrieves the date and time of the previous successful signon. */
'/*   You must have successfully called cwbSY_verifyUserIDPwd        */
'/*   before using this API.                                         */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   unsigned char * lastSignonDateTime - output                    */
'/*       A pointer to 8 bytes which will contain the date and time  */
'/*       of the last successful signon in the following format:     */
'/*                                                                  */
'/*       Bytes     Content                                          */
'/*       --------  -----------------------------------------------  */
'/*       1 - 2     Year (Example: 1994 = 0x07CA)                    */
'/*       3         Month (January = 0x01)                           */
'/*       4         Day   (First day = 0x01;31st day = 0x1F)         */
'/*       5         Hour  (Midnight = 0x01;23rd hour = 0x17)         */
'/*       6         Minute (On the hour = 0x00; 59th minute = 0x3B)  */
'/*       7         Second (On the minute = 0x00; 59th second = 0x3B)*/
'/*       8         One-hundredth of a second (on the second = 0x00; */
'/*                 maximum = 0x63                                   */
'/*                                                                  */
'/*   Note: On a given day, the maximum time is 23 hours, 59         */
'/*         minutes, and 59.99 seconds.  Midnight is 0 hours, 0      */
'/*         minutes and 0.0 seconds on the following day.            */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWBSY_NOT_VERIFIED - The user ID and password defined in       */
'/*                        object has not been verified.  Make sure  */
'/*                        you have first called                     */
'/*                        cwbSY_verifyUserIDPwd before using        */
'/*                        this API.                                 */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_GetDateTimeLastSignon(
'                             cwbSY_SecurityHandle  securityHandle,
'                             unsigned char        *lastSignonDateTime);
Public Declare Function cwbSY_GetDateTimeLastSignon Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByRef lastSignonDateTime As Byte) _
                             As Long

'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_GetDateTimePwdExpires                                    */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Retrieves the date and time the password will expire for the   */
'/*   given system.  You must have successfully called               */
'/*   cwbSY_verifyUserIDPwd before using this API.                   */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   unsigned char * expirationDateTime - output                    */
'/*       A pointer to 8 bytes which will contain the date and time  */
'/*       the password expires in the following format:              */
'/*                                                                  */
'/*       Bytes     Content                                          */
'/*       --------  -----------------------------------------------  */
'/*       1 - 2     Year (Example: 1994 = 0x07CA)                    */
'/*       3         Month (January = 0x01)                           */
'/*       4         Day   (First day = 0x01;31st day = 0x1F)         */
'/*       5         Hour  (Midnight = 0x01;23rd hour = 0x17)         */
'/*       6         Minute (On the hour = 0x00; 59th minute = 0x3B)  */
'/*       7         Second (On the minute = 0x00; 59th second = 0x3B)*/
'/*       8         One-hundredth of a second (on the second = 0x00; */
'/*                 maximum = 0x63)                                  */
'/*                                                                  */
'/*   Note: On a given day, the maximum time is 23 hours, 59         */
'/*         minutes, and 59.99 seconds.  Midnight is 0 hours, 0      */
'/*         minutes and 0.0 seconds on the following day.            */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWBSY_NOT_VERIFIED - The user ID and password defined in       */
'/*                        object has not been verified.  Make sure  */
'/*                        you have first called                     */
'/*                        cwbSY_verifyUserIDPwd before using        */
'/*                        this API.                                 */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_GetDateTimePwdExpires(
'                             cwbSY_SecurityHandle securityHandle,
'                             unsigned char       *expirationDateTime);
Public Declare Function cwbSY_GetDateTimePwdExpires Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByRef expirationDateTime As Byte) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_GetFailedAttempts                                        */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Retrieves the number of unsuccessful logon attempts.           */
'/*   You must have successfully called cwbSY_verifyUserIDPwd        */
'/*   before using this API.                                         */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   unsigned short * numberFailedAttempts - output                 */
'/*       A pointer to a short which will contain the number of      */
'/*       failed logon attempts.                                     */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWBSY_NOT_VERIFIED - The user ID and password defined in       */
'/*                        object has not been verified.  Make sure  */
'/*                        you have first called                     */
'/*                        cwbSY_verifyUserIDPwd before using        */
'/*                        this API.                                 */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_GetFailedAttempts(
'                             cwbSY_SecurityHandle  securityHandle,
'                             unsigned short       *numberFailedAttempts);
Public Declare Function cwbSY_GetFailedAttempts Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByRef numberFailedAttempts As Integer) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_GetUserID                                                */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   The API retrieves the currently logged on user ID for the      */
'/*   specified system.                                              */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   const char * systemName - input                                */
'/*       A pointer to an ASCIIZ string containing the name of the   */
'/*       AS/400 system.                                             */
'/*                                                                  */
'/*   char * userID - output                                         */
'/*       A pointer to an ASCIIZ string to receive the user ID.      */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWB_INVALID_POINTER - One of the pointers supplied as a        */
'/*                         parameter is not valid.                  */
'/*   CWBSY_SYSTEM_NOT_CONFIGURED - The system has not been          */
'/*                                 configured.                      */
'/*   CWBSY_NOT_LOGGED_ON - There is currently no user logged on     */
'/*                         for the specified system.                */
'/*   CWB_INVALID_PARAMETER - One of the parameters specified is     */
'/*                           invalid.                               */
'/*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory; may have failed   */
'/*                           to allocate temporary buffer.          */
'/*   CWB_NON_REPRESENTABLE_UNICODE_CHAR - One or more input UNICODE */
'/*                                        characters have no        */
'/*                                        representation in the     */
'/*                                        codepage being used.      */
'/*   CWB_API_ERROR - General API failure.                           */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_GetUserID(
'                             cwbSY_SecurityHandle  securityHandle,
'                             const char           *systemName,
'                             char                 *userID);
Public Declare Function cwbSY_GetUserID Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByVal systemName As String, _
                             ByRef UserID As Byte) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_Logon                                                    */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   This procedure prompts for and validates user ID and password. */
'/*   If they are valid, the information is stored and subsequent    */
'/*   sign-ons and requests for other functions are not prompted     */
'/*   for.                                                           */
'/*                                                                  */
'/*   A sign-on prompt may not be presented if the following are all */
'/*   true:                                                          */
'/*   - There is a default user ID configured for the system being   */
'/*     used (see cwbSY_setSys).                                     */
'/*   - A previous sign-on prompt was displayed where the default    */
'/*     user ID and password were used and the sign-on was           */
'/*     successful.                                                  */
'/*   In this case, the user ID and password are used again and no   */
'/*   prompt occurs.                                                 */
'/*                                                                  */
'/*   Note:  If the 'Enable caching of AS/400 passwords' option on   */
'/*          the Client Access tab of the Passwords control panel is */
'/*          not checked, you will be prompted to sign-on each time  */
'/*          the PC is restarted.  This is because the user ID and   */
'/*          password are not saved.                                 */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion                                 */
'/*   CWB_INVALID_HANDLE  - The security handle is not valid.        */
'/*   CWBSY_PASSWORD_EXPIRED - Password has expired.                 */
'/*   CWBSY_USER_CANCELLED - The user cancelled the user ID and      */
'/*                          password prompt.                        */
'/*   CWB_COMMUNICATIONS_ERROR - A communication error occurred      */
'/*                              when attempting to contact the      */
'/*                              system.                             */
'/*   CWBSY_SYSTEM_NOT_CONFIGURED - The system has not been          */
'/*                                 configured.                      */
'/*   CWBSY_LAST_INVALID_PASSWORD - The next invalid password        */
'/*                                 will disable the user profile.   */
'/*   CWBSY_USER_PROFILE_DISABLED - The user ID has been disabled.   */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   The system name must be set prior to calling this API by using */
'/*   the cwbSY_SetSys API.                                          */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_Logon(
'                             cwbSY_SecurityHandle securityHandle);
Public Declare Function cwbSY_Logon Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_SetSys                                                   */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   The API sets the name of the system in the specified security  */
'/*   object.  No validation of the system name is done.  The system */
'/*   name is checked when the user ID and password are verified     */
'/*   in the changePassword, verifyUserIDPwd, or the logon APIs.     */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   const char * systemName - input                                */
'/*       A pointer to an ASCIIZ string containing the name of the   */
'/*       AS/400 system.                                             */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle supplied is not       */
'/*                        valid.                                    */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_INVALID_PARAMETER - One of the parameters specified is     */
'/*                           invalid.                               */
'/*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory; may have failed   */
'/*                           to allocate temporary buffer.          */
'/*   CWB_NON_REPRESENTABLE_UNICODE_CHAR - One or more input UNICODE */
'/*                                        characters have no        */
'/*                                        representation in the     */
'/*                                        codepage being used.      */
'/*   CWB_API_ERROR - General API failure.                           */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   None                                                           */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_SetSys(
'                             cwbSY_SecurityHandle  securityHandle,
'                             const char           *systemName);
Public Declare Function cwbSY_SetSys Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByVal systemName As String) _
                             As Long


'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_VerifyUserIDPwd                                          */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   Verifies the user ID and password are valid for the given      */
'/*   system.                                                        */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   const char * userID - input                                    */
'/*       A pointer to an ASCIIZ string which contains the user ID.  */
'/*       The maximum length is 10 bytes + 1 byte                    */
'/*       for the NULL terminator.                                   */
'/*                                                                  */
'/*   const char * password - input                                  */
'/*       A pointer to an ASCIIZ string which contains the current   */
'/*       password.  The maximum length is 10 bytes + 1 byte for the */
'/*       NULL terminator.                                           */
'/*                                                                  */
'/*   cwbSV_ErrHandle errorHandle - output                           */
'/*     Any returned messages will be written to this object.  It    */
'/*     is created with the cwbSV_CreateErrHandle API.  The          */
'/*     messages may be retrieved through the cwbSV_GetErrText API.  */
'/*     If the parameter is set to zero, no messages will be         */
'/*     retrieved.                                                   */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle is not valid.         */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_COMMUNICATIONS_ERROR - A communication error occurred      */
'/*                              when attempting to contact the      */
'/*                              system.                             */
'/*   CWBSY_SYSTEM_NOT_CONFIGURED - The system has not been          */
'/*                                 configured.                      */
'/*   CWBSY_UNKNOWN_USERID - The supplied user ID is not             */
'/*                          known to this system.                   */
'/*   CWBSY_WRONG_PASSWORD - Password is not correct.                */
'/*   CWBSY_PASSWORD_EXPIRED - Password has expired.                 */
'/*   CWBSY_USER_PROFILE_DISABLED - The user ID has been disabled.   */
'/*   CWBSY_INVALID_PASSWORD - One or more characters in the         */
'/*                            password is invalid or the password   */
'/*                            is too long.                          */
'/*   CWBSY_INVALID_USERID - One or more characters in the user ID   */
'/*                          is invalid or the user ID is too long.  */
'/*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory; may have failed   */
'/*                           to allocate temporary buffer.          */
'/*   CWB_NON_REPRESENTABLE_UNICODE_CHAR - One or more input UNICODE */
'/*                                        characters have no        */
'/*                                        representation in the     */
'/*                                        codepage being used.      */
'/*   CWB_API_ERROR - General API failure.                           */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   The system name must set prior to calling this API by using    */
'/*   the cwbSY_SetSys API.                                          */
'/*                                                                  */
'/********************************************************************/
'Public Declare Function cwbSY_VerifyUserIDPwd(
'                              cwbSY_SecurityHandle  securityHandle,
'                              const char           *userID,
'                              const char           *password,
'                              cwbSV_ErrHandle       errorHandle);
Public Declare Function cwbSY_VerifyUserIDPwd Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByVal UserID As String, _
                             ByVal Password As String, _
                             ByVal errorHandle As Long) _
                             As Long
                             
'/********************************************************************/
'/*                                                                  */
'/* API:                                                             */
'/*   cwbSY_LogonUser                                                */
'/*                                                                  */
'/* Purpose:                                                         */
'/*   The API validates the supplied user ID and password without    */
'/*   presenting a sign-on prompt. If they are valid, the            */
'/*   information is stored and subsequent sign-ons and requests for */
'/*   other functions are not prompted for.                          */
'/*                                                                  */
'/*   Note: This API differs from cwbSY_Logon() in that a sign-on    */
'/*         prompt will not be presented because the user ID and     */
'/*         password information is being passed in on the call.     */
'/*         Also, any message dialogs (e.g. password expired) will   */
'/*         not be displayed. The return code will be set to         */
'/*         indicate these type of conditions.                       */
'/*                                                                  */
'/*   This API can be used to ensure that subsequent API function    */
'/*   calls in your program that establish connections to an AS/400  */
'/*   system will not prompt for sign-on information.                */
'/*                                                                  */
'/* Parameters:                                                      */
'/*   cwbSY_SecurityHandle securityHandle - input                    */
'/*       A valid handle to a security object.  The handle           */
'/*       is obtained using cwbSY_CreateSecurityObj.                 */
'/*                                                                  */
'/*   const char * userID - input                                    */
'/*       A pointer to an ASCIIZ string which contains the user ID.  */
'/*       The maximum length is 10 bytes + 1 byte                    */
'/*       for the NULL terminator.                                   */
'/*                                                                  */
'/*   const char * password - input                                  */
'/*       A pointer to an ASCIIZ string which contains the current   */
'/*       password.  The maximum length is 10 bytes + 1 byte for the */
'/*       NULL terminator.                                           */
'/*                                                                  */
'/*   cwbSV_ErrHandle errorHandle - output                           */
'/*     Any returned messages will be written to this object.  It    */
'/*     is created with the cwbSV_CreateErrHandle API.  The          */
'/*     messages may be retrieved through the cwbSV_GetErrText API.  */
'/*     If the parameter is set to zero, no messages will be         */
'/*     retrieved.                                                   */
'/*                                                                  */
'/* Return Codes:                                                    */
'/*   The following list shows common return values.                 */
'/*                                                                  */
'/*   CWB_OK - Successful completion.                                */
'/*   CWB_INVALID_HANDLE - The security handle is not valid.         */
'/*   CWB_INVALID_POINTER - A pointer supplied to the API is not     */
'/*                         valid.                                   */
'/*   CWB_COMMUNICATIONS_ERROR - A communication error occurred      */
'/*                              when attempting to contact the      */
'/*                              system.                             */
'/*   CWBSY_SYSTEM_NOT_CONFIGURED - The system has not been          */
'/*                                 configured.                      */
'/*   CWBSY_UNKNOWN_USERID - The supplied user ID is not             */
'/*                          known to this system.                   */
'/*   CWBSY_WRONG_PASSWORD - Password is not correct.                */
'/*   CWBSY_PASSWORD_EXPIRED - Password has expired.                 */
'/*   CWBSY_LAST_INVALID_PASSWORD - The next invalid password        */
'/*                                 will disable the user profile.   */
'/*   CWBSY_USER_PROFILE_DISABLED - The user ID has been disabled.   */
'/*   CWBSY_INVALID_PASSWORD - One or more characters in the         */
'/*                            password is invalid or the password   */
'/*                            is too long.                          */
'/*   CWBSY_INVALID_USERID - One or more characters in the user ID   */
'/*                          is invalid or the user ID is too long.  */
'/*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory; may have failed   */
'/*                           to allocate temporary buffer.          */
'/*   CWB_NON_REPRESENTABLE_UNICODE_CHAR - One or more input UNICODE */
'/*                                        characters have no        */
'/*                                        representation in the     */
'/*                                        codepage being used.      */
'/*   CWB_API_ERROR - General API failure.                           */
'/*                                                                  */
'/* Usage Notes:                                                     */
'/*   The system name must set prior to calling this API by using    */
'/*   the cwbSY_SetSys API.                                          */
'/*                                                                  */
'/********************************************************************/
'unsigned int CWB_ENTRY cwbSY_LogonUser(
'                             cwbSY_SecurityHandle  securityHandle,
'                             const char           *userID,
'                             const char           *password,
'                             cwbSV_ErrHandle       errorHandle);

Public Declare Function cwbSY_LogonUser Lib "cwbsy.dll" ( _
                             ByVal securityHandle As Long, _
                             ByVal UserID As String, _
                             ByVal Password As String, _
                             ByVal errorHandle As Long) _
                             As Long

